import pdfkit, sys, os, re
# 変換のための設定
ENCODING = 'Shift_JIS' # 入力HTMLの文字コード
FONT_SETTING = 'body{font-size: 4em; line-height: 2.0;}'
PAGE_SETTING = {
    'page-size': 'A4', 'encoding': 'UTF-8',
    'margin-top': '20mm', 'margin-right': '20mm',
    'margin-bottom': '20mm', 'margin-left': '20mm',
}
def convert_file(htmlfile):
    print("convert=", htmlfile)
    pdffile = htmlfile + '.pdf'
    # HTMLのテキストを読む
    with open(htmlfile, "rt", encoding=ENCODING) as fp:
        text = fp.read()
    # <body>から</body>以外を削除
    text = re.sub(r'(^.*<body>|</body>.*$)', '', text, flags=(re.DOTALL))
    # リンクやスクリプトがあれば削除
    text = re.sub(r'<a href.*?</a>', '', text, flags=(re.DOTALL))
    text = re.sub(r'<script.*?</script>', r'', text, flags=(re.DOTALL))
    print('抽出しました:', text[:600])
    # HTMLに変換
    html = '''
      <html><head><style>{font}</style></head>
      <body>{body}</body></html>
    '''.format(font=FONT_SETTING, body=text)
    # PDFで出力
    pdfkit.from_string(html, pdffile, options=PAGE_SETTING)
if __name__ == '__main__':
    if len(sys.argv) < 2:
        print("[使い方] convert.py (入力ファイル)"); quit()
    convert_file(sys.argv[1])
